#include <InputDebounce.h>
#include <avr/sleep.h>

//declaring the pins
const int redled1    = 10;
const int greenled1  = 9;
const int blueled1   = 11;
const int redled2    = 5;
const int greenled2  = 3;
const int blueled2   = 6;

const int ledanode1 = 13;
const int ledanode2 = 12;
const int ledanode3 = 16;
const int ledanode4 = 14;
const int ledanode5 = 4;
const int ledanode6 = 8;
const int ledanode7 = 7;

const int buttonPin = 2;
const int ledPin = 17;

static InputDebounce button;

long currentMillis = 0;
long debounceDelay = 20;    // the debounce time; increase if the output flickers
long sleepDelay = 2000;

int mode = 0;

// Color arrays
int black[3]  = { 0, 0, 0 };
int white[3]  = { 100, 100, 100 };
int red[3]    = { 100, 0, 0 };
int green[3]  = { 0, 100, 0 };
int blue[3]   = { 0, 0, 100 };
int yellow[3] = { 100, 100, 0 };
int purple[3] = { 60, 0, 70 };
int orange[3] = { 83, 40, 0 };
int cyan[3] = { 0, 100, 100 };
// etc.

// Set initial color
int redVal = black[0];
int grnVal = black[1];
int bluVal = black[2];

// Initialize color variables
int prevR = redVal;
int prevG = grnVal;
int prevB = bluVal;

int colour = 1;
int wait = 1000;      // 1000us internal crossFade delay; increase for slower fades
int hold;       // Optional hold when a color is complete, before the next crossFade

void setup() {
  pinMode(redled1, OUTPUT);
  pinMode(greenled1, OUTPUT);
  pinMode(blueled1, OUTPUT);
  pinMode(redled2, OUTPUT);
  pinMode(greenled2, OUTPUT);
  pinMode(blueled2, OUTPUT);

  pinMode(ledanode1, OUTPUT);
  pinMode(ledanode2, OUTPUT);
  pinMode(ledanode3, OUTPUT);
  pinMode(ledanode4, OUTPUT);
  pinMode(ledanode5, OUTPUT);
  pinMode(ledanode6, OUTPUT);
  pinMode(ledanode7, OUTPUT);

  button.setup(buttonPin, debounceDelay, InputDebounce::PIM_INT_PULL_UP_RES); //sets up pin 2 as a input pin with internal pullup resistor
  pinMode(ledPin, OUTPUT);

  anodeOn();

}

void loop() {
  buttonUpdate();
  switch (colour) {
    case 1:
      crossFade(white);
      break;
    case 2:
      crossFade(green);
      break;
    case 3:
      crossFade(cyan);
      break;
    case 4:
      crossFade(blue);
      break;
    case 5:
      crossFade(purple);
      break;
    case 6:
      crossFade(red);
      break;
    case 7:
      crossFade(orange);
      break;
    case 8:
      crossFade(yellow);
      break;
    default:
      crossFade(black);
      break;
  }
  colour = random(1, 8); //randomize the next colour

}

